compact3
javax.lang.model.util

## Class AbstractElementVisitor6<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    ElementVisitor<R,P>
  Direct Known Subclasses:
    AbstractElementVisitor7, ElementScanner6, SimpleElementVisitor6

      @SupportedSourceVersion(value=RELEASE_6)
      public abstract class AbstractElementVisitor6<R,P>
      extends Object
      implements ElementVisitor<R,P>

  A skeletal visitor of program elements with default behavior appropriate for the `RELEASE_6` source version.

  WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new abstract element visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Note that adding a default implementation of a new visit method in a visitor class will occur instead of adding a default method directly in the visitor interface since a Java SE 8 language feature cannot be used to this version of the API since this version is required to be runnable on Java SE 7 implementations. Future versions of the API that are only required to run on Java SE 8 and later may take advantage of default methods in this situation.

  Since:
    1.6
  See Also:
    `AbstractElementVisitor7`, `AbstractElementVisitor8`

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AbstractElementVisitor6()` | Constructor for concrete subclasses to call.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `R` | `visit(Element e)` | Visits any program element as if by passing itself to that element's `accept` method and passing `null` for the additional parameter.
    `R` | `visit(Element e, P p)` | Visits any program element as if by passing itself to that element's `accept` method.
    `R` | `visitUnknown(Element e, P p)` | Visits an unknown kind of element.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.lang.model.element.ElementVisitor

      `visitExecutable, visitPackage, visitType, visitTypeParameter, visitVariable`

- - ### Constructor Detail

    - #### AbstractElementVisitor6

          protected AbstractElementVisitor6()

      Constructor for concrete subclasses to call.

  - ### Method Detail

    - #### visit

          public final R visit(Element e,
                               P p)

      Visits any program element as if by passing itself to that element's `accept` method. The invocation `v.visit(elem)` is equivalent to `elem.accept(v, p)`.
      Specified by:
        `visit` in interface `ElementVisitor<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visit

          public final R visit(Element e)

      Visits any program element as if by passing itself to that element's `accept` method and passing `null` for the additional parameter. The invocation `v.visit(elem)` is equivalent to `elem.accept(v, null)`.
      Specified by:
        `visit` in interface `ElementVisitor<R,P>`
      Parameters:
        `e` - the element to visit
      Returns:
        a visitor-specified result

    - #### visitUnknown

          public R visitUnknown(Element e,
                                P p)

      Visits an unknown kind of element. This can occur if the language evolves and new kinds of elements are added to the `Element` hierarchy.

      The default implementation of this method in `AbstractElementVisitor6` will always throw `UnknownElementException`. This behavior is not required of a subclass.

      Specified by:
        `visitUnknown` in interface `ElementVisitor<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result
      Throws:
        `UnknownElementException` - a visitor implementation may optionally throw this exception

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.